      SUBROUTINE WRITEOUT

      INCLUDE 'includepar'
      INCLUDE 'includecom'

C     writes out cluster results,at iteration level with maximum change
C     of rrx (intra-cluster coherence)

C     determine the iteration level with the maximum change of rrx

C     initialise variables to find maximum change in coherence
      DRMAX = 0. ! absolute change
      DRMAXREL = 0. ! relative change

C     define interval of clustering levels which will be searched
C     for the maximum
C      IDMAX = ITR-20
      IF (ITR .LE. 20) STOP 'not enough matrix elements for writeout'
      ISTART = ITR-20

C     initialise variables defining the clustering level of maximum      
      IDRMAX = ISTART
      IDRMAXREL = ISTART
      
      IS = ISTART !just an abbreviation for next two lines
C     set first values      
      DRMAX = (RRX(IS) - RRX(IS-1))
      DRMAXREL = (RRX(IS) - RRX(IS-1)) / (RRX(IS) + RRX(IS-1))

      DO I = ISTART,ITR
         DR = (RRX(I) - RRX(I-1)) ! change in coherence
         DRREL = (RRX(I) - RRX(I-1)) / (RRX(I) + RRX(I-1))  ! rel. change
         IF (DR .GT. DRMAX) THEN
            IDRMAX = I
            DRMAX = DR
         ENDIF  
         IF (DRREL .GT. DRMAXREL) THEN
            IDRMAXREL = I
            DRMAXREL = DRREL
         ENDIF  
         PRINT '(I4,5F12.4)', ITR-I+1,RRX(I),DR,DRMAX,DRREL,DRMAXREL
      ENDDO   

C     idmax is the suggested clustering level
      IDMAX = IDRMAXREL - 1 ! this seems to be better than idrmax

C     if a fixed number of clusters shall be used, set it in the
C     next (commented) code line (example is for getting seven clusters):
C      IDMAX = ITR-6

C     write out final result   
      OPEN (22, FILE = 'cluster_1')

C     loop over all different elements 
      DO I = 1,NDATES
           WRITE (22,'(I3,2X,A50)') ICLU(I,IDMAX), CDATE(I)
      ENDDO
      
      CLOSE (22)
      
      RETURN
      END
